package service

import (
	"errors"

	"github.com/bytedance/sonic"
	"github.com/go-admin-team/go-admin-core/sdk/service"
	"gorm.io/gorm"

	"go-admin/app/admin/models"
	"go-admin/app/admin/service/dto"
	"go-admin/common/actions"
	"go-admin/common/const/rediskey"
	cDto "go-admin/common/dto"
	"go-admin/common/helper"
)

type LineSystemSetting struct {
	service.Service
}

// GetPage 获取LineSystemSetting列表
func (e *LineSystemSetting) GetPage(c *dto.LineSystemSettingGetPageReq, p *actions.DataPermission, list *[]models.LineSystemSetting, count *int64) error {
	var err error
	var data models.LineSystemSetting

	err = e.Orm.Model(&data).
		Scopes(
			cDto.MakeCondition(c.GetNeedSearch()),
			cDto.Paginate(c.GetPageSize(), c.GetPageIndex()),
			actions.Permission(data.TableName(), p),
		).
		Find(list).Limit(-1).Offset(-1).
		Count(count).Error
	if err != nil {
		e.Log.Errorf("LineSystemSettingService GetPage error:%s \r\n", err)
		return err
	}
	return nil
}

// Get 获取LineSystemSetting对象
func (e *LineSystemSetting) Get(d *dto.LineSystemSettingGetReq, p *actions.DataPermission, model *models.LineSystemSetting) error {
	var data models.LineSystemSetting

	err := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).
		First(model, d.GetId()).Error
	if err != nil && errors.Is(err, gorm.ErrRecordNotFound) {
		err = errors.New("查看对象不存在或无权查看")
		e.Log.Errorf("Service GetLineSystemSetting error:%s \r\n", err)
		return err
	}
	if err != nil {
		e.Log.Errorf("db error:%s", err)
		return err
	}
	return nil
}

// Insert 创建LineSystemSetting对象
func (e *LineSystemSetting) Insert(c *dto.LineSystemSettingInsertReq) error {
	var err error
	var data models.LineSystemSetting
	c.Generate(&data)
	err = e.Orm.Create(&data).Error
	if err != nil {
		e.Log.Errorf("LineSystemSettingService Insert error:%s \r\n", err)
		return err
	}

	val, _ := sonic.MarshalString(data)

	if val != "" {
		if err := helper.DefaultRedis.SetString(rediskey.SystemSetting, val); err != nil {
			e.Log.Error("LineSystemSettingService Update redis set error:%s \r\n", err)
		}
	}

	return nil
}

// Update 修改LineSystemSetting对象
func (e *LineSystemSetting) Update(c *dto.LineSystemSettingUpdateReq, p *actions.DataPermission) error {
	var err error
	var data = models.LineSystemSetting{}
	e.Orm.Scopes(
		actions.Permission(data.TableName(), p),
	).First(&data, c.GetId())
	c.Generate(&data)

	db := e.Orm.Save(&data)
	if err = db.Error; err != nil {
		e.Log.Errorf("LineSystemSettingService Save error:%s \r\n", err)
		return err
	}
	if db.RowsAffected == 0 {
		return errors.New("无权更新该数据")
	}

	val, _ := sonic.MarshalString(data)

	if val != "" {
		if err := helper.DefaultRedis.SetString(rediskey.SystemSetting, val); err != nil {
			e.Log.Error("LineSystemSettingService Update redis set error:%s \r\n", err)
		}
	}

	return nil
}

// Remove 删除LineSystemSetting
func (e *LineSystemSetting) Remove(d *dto.LineSystemSettingDeleteReq, p *actions.DataPermission) error {
	var data models.LineSystemSetting

	db := e.Orm.Model(&data).
		Scopes(
			actions.Permission(data.TableName(), p),
		).Delete(&data, d.GetId())
	if err := db.Error; err != nil {
		e.Log.Errorf("Service RemoveLineSystemSetting error:%s \r\n", err)
		return err
	}
	if db.RowsAffected == 0 {
		return errors.New("无权删除该数据")
	}

	return nil
}
